# MindForger <!-- Metadata: type: Outline; tags: read-this-first; created: 2018-02-23 10:57:35; reads: 228; read: 2020-01-15 08:48:43; revision: 228; modified: 2020-01-15 08:48:43; importance: 5/5; urgency: 3/5; -->

MindForger is **personal thinking notebook** and **Markdown editor**:

* Check getting started and features walkthrough [YouTube video](https://t.co/ym1KKEny3y)

[![MindForger](mindforger.png)](https://t.co/ym1KKEny3y)

MindForger project motivation and inspiration:

* [Why MindForger?](why-mindforger.md)

How to install MindForger?

* [Installation](installation.md)

How to use MindForger?

* [User documentation](./user-documentation.md), [FAQ](faq.md) and [YouTube video](https://t.co/ym1KKEny3y)

What are interesting (collections of) Markdown documents?

* [Markdown content and examples](#markdown-content-and-examples)

How to clone, build, improve, research, tweak and contribute?

* [Developer documentation](./developer-documentation.md)

What's MindForger project history?

* [History](history.md)

For more details see also MindForger project home https://www.mindforger.com

---

💡 click a note in the tree of notes on the left to see other sections of this notebook.

💡 click menu `View/Outlines` or press <kbd>Ctrl+Shift+O</kbd> to view all documents in MindForger
documentation repository.

---

_Made with passion for personal pleasure._

# User Documentation <!-- Metadata: type: Note; created: 2018-02-23 10:57:35; reads: 25; read: 2018-05-29 22:42:54; revision: 5; modified: 2018-05-29 22:42:54; -->
Understand motivation, install, configure and use:

* [Why MindForger?](why-mindforger.md)
* [Installation](installation.md)
* [Configuration](configuration.md)
* [Documentation](user-documentation.md)
* [FAQ](mindforger/faq.md)
* [History](history.md)

# Developer Documentation <!-- Metadata: type: Note; created: 2018-03-18 09:10:35; reads: 21; read: 2018-05-29 22:42:33; revision: 9; modified: 2018-05-29 22:42:33; -->
Clone, build, improve, research, tweak, contribute:

* [Developer documentation](developer-documentation.md)

# Markdown content and examples <!-- Metadata: type: Note; tags: example; created: 2018-05-01 22:28:00; reads: 59; read: 2020-01-15 08:45:25; revision: 52; modified: 2020-01-15 08:45:25; -->

If you want to use MindForger as Markdown editor, then
you may want to check examples of various documents (collections)
below. 

Simply clone Git repository and open it from its root 
directoring using MindForger:

* [ProGit](https://github.com/progit/progit)
    * `git clone https://github.com/progit/progit && cd progit && mindforger .`
* [JavaScript algorithms](https://github.com/trekhleb/javascript-algorithms)
    * `git clone https://github.com/trekhleb/javascript-algorithms && cd javascript-algorithms && mindforger .`
* [Pure Bash bible](https://github.com/dylanaraps/pure-bash-bible)
    * `git clone https://github.com/dylanaraps/pure-bash-bible && cd pure-bash-bible && mindforger .`
* [Awesome AI services](https://github.com/sekwiatkowski/awesome-ai-services)
    * `git clone https://github.com/sekwiatkowski/awesome-ai-services && cd awesome-ai-services && mindforger .`
* [Build your own X](https://github.com/danistefanovic/build-your-own-x)
    * `git clone https://github.com/danistefanovic/build-your-own-x && cd build-your-own-x && mindforger .`
* [Front-end Handbook 2018](https://github.com/FrontendMasters/front-end-handbook-2018)
    * `git clone https://github.com/FrontendMasters/front-end-handbook-2018 && cd front-end-handbook-2018 && minforger .`
* [NYTimes Objective-C style guide](https://github.com/NYTimes/objective-c-style-guide)
    * `git clone https://github.com/NYTimes/objective-c-style-guide && cd objective-c-style-guide && mindforger .`
* [LivingSocial API design](https://github.com/livingsocial/api-design)
    * `git clone https://github.com/livingsocial/api-design && cd api-design && mindforger .`
* [C++ core guidelines](https://github.com/isocpp/CppCoreGuidelines)
    * `git clone https://github.com/isocpp/CppCoreGuidelines && cd CppCoreGuidelines && mindforger .`
* [AI computer vision resources](https://github.com/jbhuang0604/awesome-computer-vision)
    * `git clone https://github.com/jbhuang0604/awesome-computer-vision && cd awesome-computer-vision && mindforger .`
* [FiveThirtyEight data sources](https://github.com/fivethirtyeight/data)
    * `git clone https://github.com/fivethirtyeight/data && cd data && mindforger .`

See also [awesome Markdown repositories](https://github.com/dvorka/awesome-markdown-repositories) for more examples.
