# GROW

Grow Outline:

* G ... goal
* R ... reality
* O ... options
* W ... way forward



# Goal
Goal - clearly describe what you want to achieve or solve and
why. Evaluate your goal and make any changes necessary to ensure it
meets the criteria for a SMARTER goal - see checklist below for more
details.

Use to following checklist to ensure that the goal is **S.M.A.R.T.E.R**:

* [x] the goal is specific
* [ ] the goal is measurable
* [ ] the goal is attainable
* [ ] the goal is realistic
* [ ] the goal is timeable
* [ ] the goal is exciting
* [ ] the goal is resources

My goal is ...

## How can I describe the goal?
...
## How can I describe the problem I want to solve?
...
## How much personal control or influence do I have over my goal?
...
## Do I want to achieve this goal in short-term or long-term?
...
## How will I know that I have achieved the goal?
...
## Is the goal attainable?
...
## Is the goal challenging?
...
## Is the goal positive?
...
## What I wish to achieve?
...
## When do I want to achieve it by?
...
## How will I know the problem is solved?
...
## How will I measure it?
...
## What does success look like?
...
## What I wish to achieve?
...
## What is my motivation?
...
## What would be the milestones on the way?
...
## When do I want to achieve it by?
...
## Why I want to achieve this goal?
...




# Reality
Reality - describe the current situation, relevant history and
possibly also expected future. Focus on facts and avoid emotional
distortion of the reality. Try to determine whether there is a missing
piece of information you need to achieve the goal.

Consider the use of **S.W.O.T. analysis** to assess your situation.

## How can I asses myself in the context of the goal?
...
## What have I done about this so far?
...
## What things are going badly on this issue, what happens to me?
...
## What I already did and what was the result?
...
## What is holding me back from finding a way forward?
...
## What is involved - directly or indirectly?
...
## What is the effect of this in 10 days, 10 months and 10 years (10:10:10 rule)
...
## What things are going badly on this issue, what happens to me?
...



# Options
Options - describe how could you achieve the goal - what are your
options in particular. Elaborate also opportunities, obstacles,
objectives and dead ends. Focus on your strengths and abilities, and
build on them. At the same time, be reflective and recognize where you
could need help. Use an infrastructure around yourself by reaching out
to relatives, friends and colleagues. Sometimes you can't do
everything yourself - no one has all the capabilities and competencies
to do what is needed.

Consider the use of **S.W.O.T. analysis** to assess options.

## Do I know a promissing option with obstacles? How can I remove these obstacles one by one?
...
## How do I ensure my weaknesses will not stop me from opportunities?
...
## How do I leverage my strengths to benefit from opportunities?
...
## How do I use my strengths to minimize impact of threats?
...
## How will I fix weaknesses that can make threats have a real impact?
...
## What are the options that I should definitely avoid?
...
## What else could I do?
...
## What if analysis...? (triangle: time, power, money)
...
## What is the wrong approach? What I should definitely avoid?
...
## What options do I have?
...
## Who can support me? Who can I ask for help?
...
## Who or where can I ask?
...
## Would I need another suggestion?
...



# Way Forward
Way forward - - what, where, when and how. Describe what you will do
and what are the actions to be performed. Elaborate way forward and
your will. Give yourself tasks based on the option you have selected
in the previous step. Execute - if you do at least one small thing for
your dream everyday, you will succeed.

Formulate **action plan** - it is your way towards the goal. It
summarizes task and action items you specified in this step.

## How can I start? What should I do first?
...
## How likely is this option to succeed?
...
## How will I overcome problems that may slow me down or stop me?
...
## Is there anything else I want to elaborate or the actions finished?
...
## What commitment on a 1 - 10 scale do I have taking these identified actions?
...
## What could arise to hinder me in taking these steps?
...
## What could I do or alter to raise my commitment closer to 10?
...
## What else can I do?
...
## What is the meaningful order of actions and tasks?
...
## What personal resistance do I have, if any, to taking these steps?
...
## What support do I need and from whom?
...
## What will I do now and what later?
...
## What will I do to eliminate these external and internal factors?
...
## What will I do to obtain that support and from whom?
...
## What will I do to obtain that support and when?
...
## When precisely am I going to start and finish each action step?
...
## Which actions I can do immediately?
...
## Which actions will I do later? Why can I afford to postpone them?
...
## Which options or option do I choose?
...



# !

Conclude what you have learned and wrap up. Both general lessons
learned, mistakes and experiences specifically related to this
goal are worth to remember.

Summarize results, lessons learned, mistakes, interesting solutions
and experiences.

## Could I move faster? What would be the risk?
...
## Could I move more efficiently?
...
## How am I satisfied with the overall result?
...
## What are the results of actions I did up until now?
...
## What can I perform better next time?
...
## What did I learned?
...
## What is the feedback of involved/impacted people?
...
## What is the most valuable experience?
...
## What should I avoid next time?
...
## What would I do different if I have chance to return to the beginning again?
...
## With which result in particular I'm not satisfied?
...
## With which result in particular I'm satisfied?
...


